From ae004d6b98fa6a30e2cbf9f9224fbde7d0e40439 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 00:36:42 +0000
Subject: [PATCH 1262/2232] Add string intern set


---

diff --git a/gen/build/src/intern.rs b/gen/build/src/intern.rs
new file mode 100644
index 0000000..800b8a3
--- /dev/null
+++ b/gen/build/src/intern.rs
@@ -0,0 +1,28 @@
+use lazy_static::lazy_static;
+use std::collections::HashSet;
+use std::sync::{Mutex, PoisonError};
+
+#[derive(Copy, Clone)]
+pub struct InternedString(&'static str);
+
+impl InternedString {
+    pub fn str(self) -> &'static str {
+        self.0
+    }
+}
+
+pub fn intern(s: &str) -> InternedString {
+    lazy_static! {
+        static ref INTERN: Mutex<HashSet<&'static str>> = Mutex::new(HashSet::new());
+    }
+
+    let mut set = INTERN.lock().unwrap_or_else(PoisonError::into_inner);
+    InternedString(match set.get(s) {
+        Some(interned) => *interned,
+        None => {
+            let interned = Box::leak(Box::from(s));
+            set.insert(interned);
+            interned
+        }
+    })
+}
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 3e37143..b4a455a 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -57,6 +57,7 @@
 mod cfg;
 mod error;
 mod gen;
+mod intern;
 mod out;
 mod paths;
 mod syntax;

